--
-- Table structure for table `track_list`
--

CREATE TABLE  `track_list` (
  `track_id` bigint(20) NOT NULL auto_increment,
  `site_url` text NOT NULL,
  `added_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_visit` datetime NOT NULL default '0000-00-00 00:00:00',
  `total_hits` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`track_id`)
)COMMENT='List of URLS to be tracked' ;


--
-- Table structure for table `track_shorts`
--

CREATE TABLE `track_shorts` (
  `short_id` bigint(20) unsigned NOT NULL auto_increment,
  `short_url` text NOT NULL,
  `short_short` varchar(255) NOT NULL default '',
  `short_hits` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`short_id`)
)  COMMENT='List of short urls' ;


--
-- Table structure for table `track_visits`
--

CREATE TABLE  `track_visits` (
  `visit_id` bigint(20) NOT NULL auto_increment,
  `track_id` bigint(20) NOT NULL default '0',
  `visit_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `visit_ip` varchar(100) NOT NULL default '',
  `visit_from` text NOT NULL,
  PRIMARY KEY  (`visit_id`),
  KEY `track_id` (`track_id`)
)  COMMENT='List of all visitors' ;